# t=0 : AA ; t=1 : CIF
def resultant(I,t):
    RS=[]
    J=[]
    for (i,j) in I:
        try:
            R=ZZ[r](eqpc[i].resultant(eqpc[j],s))
            S=ZZ[s](eqpc[i].resultant(eqpc[j],r))
            RR=[]
            SS=[]
            # racines des facteurs pas forcément distinctes : redondance
            for R in [f[0] for f in factor(R) if not inutile(f[0])]:
                if t==0:
                    RR+=R.roots(AA,multiplicities=false)
                else:
                    RR+=[x.real() for x in R.roots(CIF,multiplicities=false) if x.imag().contains_zero()]
            for S in [f[0] for f in factor(S) if not inutile(f[0])]:
                if t==0:
                    SS+=S.roots(AA,multiplicities=false)
                else:
                    SS+=[x.real() for x in S.roots(CIF,multiplicities=false) if x.imag().contains_zero()]
            z=flatten([[((i,j),(rr,ss)) for rr in RR] for ss in SS],max_level=1)
            RS+=z
        except:
            print('(%2d,%3d) : %s'%(i,j,str(sys.exc_info())))
            J.append((i,j))
    return (RS,J)

def passe2(RS):
    RS2=[]
    for ((i,j),(rr,ss)) in RS:
        if verif_couronne(pc[i],0,rr,ss):
            if verif_couronne(pc[j],0,rr,ss):
                RS2.append(((i,j),(rr,ss)))
    return RS2

def passe3(RS):
    RS2=[]
    for ((i,j),(rr,ss)) in RS:
        p=couronnes_compatibles(rr,ss,0)
        if len(p)>1: # 2pc ou plus
            m=couronnes_compatibles(rr,ss,1)
            m=[k for k in m if not trou_vide(k,1,rr,ss)] # vire les couronnes avec interstice remplissable non rempli
            if len(m)>0:
                g=couronnes_compatibles(rr,ss,2)
                g=[k for k in g if not trou_vide(k,2,rr,ss)] # vire les couronnes avec interstice remplissable non rempli
                if len(g)>0:
                    RS2.append(((i,j),(rr,ss),(p,m,g)))
    return RS2

# idem 1pc
def passe4(RS):
    acceptes=[]
    rejetes=[]
    fails=[]
    for (ij,(rr,ss),(p,m,g)) in RS:
        try:
            k=0
            p2=[px for px in p if verif_equation(px,0,rr,ss)]
            k+=1
            m2=[mx for mx in m if verif_equation(mx,1,rr,ss)]
            k+=1
            g2=[gx for gx in g if verif_equation(gx,2,rr,ss)]
            if len(p2)*len(m2)*len(g2)>0:
                acceptes.append((ij,(rr,ss),(p2,m2,g2)))
                print('+')
            else:
                rejetes.append((ij,(rr,ss),(p2,m2,g2)))
                print('-')
        except:
            fails.append((ij,(rr,ss),(p,m,g)))
            print('Erreur sur %s couronne : %s'%(['petite','moyenne','grande'][k],str(sys.exc_info()[1])))
    return (acceptes,rejetes,fails)


############################################

pc=petites_couronnes()
eqpc=[equation(i,0) for i in pc]
K.inject_variables()

# pc sans 1
A=[i for i in range(55) if not '1' in sequence(pc[i])]
# pc sans r
B=[i for i in range(55) if not 'r' in sequence(pc[i])]
# pc avec r ou 1
C=[i for i in range(55) if 'r' in sequence(pc[i]) or '1' in sequence(pc[i])]

# 1395 couples pc/pc
# candidats initiaux : toutes les paires sauf celles ds AxA et BxB
I=[(i,j) for i in range(54) for j in range(i+1,55) if not (i in A and j in A) and not (i in B and j in B)]
# tous de dimension 0 (vérif en 25s)
I0=[(i,j) for (i,j) in I if ideal(K,[eqpc[i],eqpc[j]]).dimension()==0]

# résultants sur AA puis CIF pour erreurs
E=[(4,37),(5,38),(17,52)]
I0.remove((4,37))
I0.remove((5,38))
I0.remove((17,52))
(RS,E)=resultant(I0,0) # 1min 10s, 185813 couples, 3 erreurs :
# (4,37) : Assertion
# (5,38) : RunTime
# (17,52) : interrompu (trop long, >3h)
#(RSE,E2)=resultant(E,1) # 1.4s, 2276 couples, tout passe

# variante : les traiter par ideal variety ?
# v1=ideal(K,[eqpc[4],eqpc[37]]).variety(AA) # 2.91s, 11 couples
# v2=ideal(K,[eqpc[5],eqpc[38]]).variety(AA) # trop long (>2h)
# v3=ideal(K,[eqpc[17],eqpc[52]]).variety(AA) # 12.3s, 26 couples

# passe 1 : domaine
RS1=[(k,(rr,ss)) for (k,(rr,ss)) in RS if 0<RIF(ss) and RIF(ss)<RIF(rr) and RIF(rr)<1] # 1394, 3s
RS1E=[(k,(rr,ss)) for (k,(rr,ss)) in RSE if 0<RIF(ss) and RIF(ss)<RIF(rr) and RIF(rr)<1] # 179, immédiat

# passe 2 : équations angles pc et mc :
RS2=passe2(RS1) # 312 en 3s
RS2E=passe2(RS1E) # 0 immédiat

# passe 3 : existence grande couronne
RS3=passe3(RS2) # 37 en 31.7 s
RS3.sort()

# vérif exacte sur équation (avant élimination racines) : tout passe en 32.1 s
(RS4a,RS4r,RS4f)=passe4(RS3)

