
# écriture canonique d'une séquence : minimale pour ordre lexico parmi ses shiftées et inversées
def canonique(l):
    lr=copy(l)
    lr.reverse()
    z=[[l[mod(j+i,len(l))] for j in range(len(l))] for i in range(len(l))]
    z=z+[[lr[mod(j+i,len(lr))] for j in range(len(lr))] for i in range(len(lr))]
    z.sort()
    x=''
    for i in range(len(l)):
        x=x+z[0][i]
    return x

# renvoie le tuple des angles correspondant à une séquence
def angles(w):
    k=[0,0,0,0,0,0]
    n=len(w)
    for i in range(n):
        if {w[i],w[mod(i+1,n)]}=={'1'}:
            k[0]=k[0]+1
        if {w[i],w[mod(i+1,n)]}=={'1','r'}:
            k[1]=k[1]+1
        if {w[i],w[mod(i+1,n)]}=={'1','s'}:
            k[2]=k[2]+1
        if {w[i],w[mod(i+1,n)]}=={'r'}:
            k[3]=k[3]+1
        if {w[i],w[mod(i+1,n)]}=={'r','s'}:
            k[4]=k[4]+1
        if {w[i],w[mod(i+1,n)]}=={'s'}:
            k[5]=k[5]+1
    return tuple(k)

# sequences associées à l'angle k
# parcours tous les chemins possible dans le graphe des angles (plus rapide)
# l'idéal serait de faire un générateur avec "yield" mais pas évident à cause de la récursivité (odomètre ?)
def sequences(k):
    if k[0]+k[1]+k[2]>0:
        return aux_sequences(vector(k),'','1',false)
    elif k[3]+k[1]+k[4]>0:
        return aux_sequences(vector(k),'','r',false)
    else:
        return aux_sequences(vector(k),'','s',false)
        
# une seule séquence (la première trouvée)
def sequence(k):
    try:
        if k[0]+k[1]+k[2]>0:
            return aux_sequences(vector(k),'','1',true)
        elif k[3]+k[1]+k[4]>0:
            return aux_sequences(vector(k),'','r',true)
        else:
            return aux_sequences(vector(k),'','s',true)
    except Exception as seq:
        return seq.args[0]

def aux_sequences(k,u,e,une):
    if k==0:
        if une:
            raise Exception(canonique(list(u)))
        else:
            return set([canonique(list(u))])
    l=set()
    if e=='1':
        if k[0]>0:
            l.update(aux_sequences(k-vector((1,0,0,0,0,0)),u+'1','1',une))
        if k[1]>0:
            l.update(aux_sequences(k-vector((0,1,0,0,0,0)),u+'r','r',une))
        if k[2]>0:
            l.update(aux_sequences(k-vector((0,0,1,0,0,0)),u+'s','s',une))
    elif e=='r':
        if k[3]>0:
            l.update(aux_sequences(k-vector((0,0,0,1,0,0)),u+'r','r',une))
        if k[1]>0:
            l.update(aux_sequences(k-vector((0,1,0,0,0,0)),u+'1','1',une))
        if k[4]>0:
            l.update(aux_sequences(k-vector((0,0,0,0,1,0)),u+'s','s',une))
    else:
        if k[5]>0:
            l.update(aux_sequences(k-vector((0,0,0,0,0,1)),u+'s','s',une))
        if k[4]>0:
            l.update(aux_sequences(k-vector((0,0,0,0,1,0)),u+'r','r',une))
        if k[2]>0:
            l.update(aux_sequences(k-vector((0,0,1,0,0,0)),u+'1','1',une))
    return l
    
# les quantités d'angles k correspondent-ils à une vraie couronne ?
def couronnable(k):
    # nombre entier de disques de chaque taille
    a=mod(k[1]+k[2],2)==0 and mod(k[1]+k[4],2)==0 and mod(k[2]+k[4],2)==0
    # si yxy alors soit que des y, soit yxz ou zxy
    b=k[1]<>0 or k[2]<>0 or k[0]==0 or (k[1]==0 and k[2]==0 and k[3]==0 and k[4]==0 and k[5]==0)
    c=k[1]<>0 or k[4]<>0 or k[3]==0 or (k[0]==0 and k[1]==0 and k[2]==0 and k[4]==0 and k[5]==0)
    d=k[2]<>0 or k[4]<>0 or k[5]==0 or (k[0]==0 and k[1]==0 and k[2]==0 and k[3]==0 and k[4]==0)
    # cycle possible sur le triangle reliant 1, r et s, avec k donnant nb passages par arête
    z=min(k[1],k[2],k[4])
    e=mod(k[1]-z,2)==0 and mod(k[2]-z,2)==0 and mod(k[4]-z,2)==0
    return a and b and c and d and e

# renvoie toutes les petites couronnes possibles (sauf ssssss)
# les 10 premières sont celles sans grand disque
def petites_couronnes():
    pc=[]
    for k in cartesian_product([range(6) for i in range(6)]):
        if couronnable(k) and k[0]+k[1]+k[2]+k[3]+k[4]+k[5]<6 and 6<3*k[0]+3*k[1]+3/2*k[2]+3*k[3]+3/2*k[4]+k[5]:
            pc.append(tuple(k))
    return pc

# ratio algébrique s/r donné par les pc 0 à 9 (ds cet ordre)
var('x')
kennedy=[
AA(sin(pi/12)/(1-sin(pi/12))),
AA(5-2*sqrt(6)),
AA((2*sqrt(3)+1-2*sqrt(1+sqrt(3)))/3),
AA(ZZ[x](8*x^3+3*x^2-2*x-1).roots(AA)[0][0]),
AA((sqrt(17)-3)/4),
AA(ZZ[x](x^8 - 8*x^7 - 44*x^6 - 232*x^5 - 482*x^4 - 24*x^3 + 388*x^2 - 120*x + 9).roots(AA)[2][0]),
AA(2/sqrt(3)-1),
AA(ZZ[x](x^4-10*x^2-8*x+9).roots(AA)[0][0]),
AA(sqrt(2)-1),
AA(1/sin(pi/5)-1)]

# renvoie toutes les moyennes couronnes compatibles avec une petite couronne k
# en garde a priori bcp trop car pour filtrer utilise le ratio s/r donné par 2 disques, qui n'est qu'une borne inf quand il y a trois disques !
# k=pc[1] pour tout avoir
# toutes en 1min
def moyennes_couronnes(k):
    # a : borne inf sur le ratio s/r en fonction de la petite couronne k
    k2=angles(sequence(k).replace('1','r'))
    a=RIF(kennedy[pc.index(k2)])
    # calcule valeurs max des entiers l3, l5 et l6
    ua=RIF(arccos(1/(1+a)))
    va=RIF(arccos(1-2*a^2/(1+a)^2))
    dp=RIF(2*pi)
    l3=floor((dp/ua).endpoints()[1])
    l5=l3
    l6=floor((dp/va).endpoints()[1])
    # trouve les mc en parcourant tous les l possibles (on pourrait raffiner comme pour couronnes compatibles)
    mc=[]
    for l in cartesian_product([range(6),range(6),range(l3+1),range(6),range(l5+1),range(l6+1)]):
        b=(l[0]+l[1]+l[3]+RIF(3/pi)*(l[2]*ua+l[4]*ua+l[5]*va)).endpoints()[0]
        c=3*l[0]+3/2*l[1]+3/2*l[2]+l[3]+l[4]+l[5]        
        if b<6 and 6<c and l[0]+l[1]+l[3]+(l[2]+l[4])/2<6 and couronnable(l):
            mc.append(tuple(l))
    return mc
    
def angle(x,y,z):
    return arccos(((y+x)^2+(y+z)^2-(x+z)^2)/2/(y+x)/(y+z))

# cherche toutes les couronnes possibles de type tc pour r et s donnés
# n'en rate aucune mais peut aussi proposer des faux (arithmétique d'intervalle)
# long (on pourrait préfiltrer en approx entières des angles et cython ou ocaml)
def couronnes_compatibles(rr,ss,tc):
    rrr=RIF(rr)
    sss=RIF(ss)
    un=RIF(1)
    dp=RIF(2*pi)
    z=[sss,rrr,un][tc]
    a=[angle(un,z,un),angle(un,z,rrr),angle(un,z,sss),angle(rrr,z,rrr),angle(rrr,z,sss),angle(sss,z,sss)]
    candidates=[]
    for k0 in range(floor((dp/a[0]).endpoints()[1])+1):
        for k1 in range(floor(((dp-k0*a[0])/a[1]).endpoints()[1])+1):
            for k2 in range(floor(((dp-k0*a[0]-k1*a[1])/a[2]).endpoints()[1])+1):
                for k3 in range (floor(((dp-k0*a[0]-k1*a[1]-k2*a[2])/a[3]).endpoints()[1])+1):
                    for k4 in range (floor(((dp-k0*a[0]-k1*a[1]-k2*a[2]-k3*a[3])/a[4]).endpoints()[1])+1):
                        k5f=((dp-k0*a[0]-k1*a[1]-k2*a[2]-k3*a[3]-k4*a[4])/a[5])
                        for k5 in range(max(0,floor(k5f.endpoints()[0])), floor(k5f.endpoints()[1])+1):
                            if (dp-k0*a[0]-k1*a[1]-k2*a[2]-k3*a[3]-k4*a[4]-k5*a[5]).contains_zero():
                                k=tuple((k0,k1,k2,k3,k4,k5))
                                if (tc==0 and k5+(k2+k4)/2<=6) or (tc==1 and k3+(k1+k4)/2<=6) or (tc==2 and k0+(k1+k2)/2<=6):
                                    if couronnable(k):
                                        candidates.append(k)
    # vire hexagonal compact
    candidates.remove([(0,0,0,0,0,6),(0,0,0,6,0,0),(6,0,0,0,0,0)][tc])
    return candidates

# vérifie si la couronne k de type tc est compatible avec r et s donnés
# si renvoit faux alors incompatible, sinon PROBABLEMENT compatible (arithmétique d'intervalle)
def verif_couronne(k,tc,rr,ss):
    rrr=RIF(rr)
    sss=RIF(ss)
    un=RIF(1)
    dp=RIF(2*pi)
    z=[sss,rrr,un][tc]
    e=k[0]*angle(un,z,un)+k[1]*angle(un,z,rrr)+k[2]*angle(un,z,sss)+k[3]*angle(rrr,z,rrr)+k[4]*angle(rrr,z,sss)+k[5]*angle(sss,z,sss)-dp
    return e.contains_zero()






